window.Gleam.initSearch([{"doc":"httpp","title":"httpp","content":"# httpp\n\n[![Package Version](https://img.shields.io/hexpm/v/httpp)](https://hex.pm/packages/httpp)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/httpp/)\n\n```sh\ngleam add httpp\n```\n```gleam\nimport httpp/async\nimport gleam/http/request\nimport gleam/uri\nimport gleam/bytes_builder\nimport gleam/erlang/process\n\npub fn main() {\n  let response_subject = uri.parse(&quot;https://example.com&quot;)\n  |&gt; request.from_uri\n  |&gt; request.map(bytes_builder.from_string)\n  |&gt; async.send\n\n  // asynchronously send an http request and receive it later\n  process.receive(response_subject, 2000)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/httpp&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"httpp/hackney","title":"ClientRef","content":"pub type ClientRef\n A hackney client_ref\n\nSynonyms:\nhttpp/hackney.ClientRef\nhttpp/hackney ClientRef","url":"httpp/hackney.html#ClientRef"},{"doc":"httpp/hackney","title":"Error","content":"pub type Error {\n  Other(Dynamic)\n  ConnectionClosed(partial_body: BitArray)\n  TimedOut\n  NoStatusOrHeaders\n  InvalidUtf8Response\n  NoClientRefReturned\n  UnexpectedServerMessage(HttppMessage)\n  MessageNotDecoded(Dynamic)\n}\n\nOther(Dynamic)\n Hackney Error Type\n\nConnectionClosed(partial_body: BitArray)\n Error returned when the connection is unexpectedly closed\n\nTimedOut\n\n\nNoStatusOrHeaders\n\n\nInvalidUtf8Response\n could not decode BitArray to string\n\nNoClientRefReturned\n when expecting a client ref, we did not get one back\n\nUnexpectedServerMessage(HttppMessage)\n when the client has already received a message and doesn&#39;t expect the message\n\nMessageNotDecoded(Dynamic)\n when the client receives a message that it can&#39;t decode\n\nSynonyms:\nhttpp/hackney.Error\nhttpp/hackney Error","url":"httpp/hackney.html#Error"},{"doc":"httpp/hackney","title":"HackneyResponse","content":"pub type HackneyResponse {\n  ClientRefResponse(\n    status: Int,\n    headers: List(Header),\n    client_ref: ClientRef,\n  )\n  BinaryResponse(\n    status: Int,\n    headers: List(Header),\n    body: BitArray,\n  )\n  EmptyResponse(status: Int, headers: List(Header))\n  AsyncResponse(client_ref: ClientRef)\n}\n Response of the hackney http client\nClientRefResponse(\n  status: Int,\n  headers: List(Header),\n  client_ref: ClientRef,\n)\n Received on response when neither `WithBody` or `Async` are used\n\nBinaryResponse(\n  status: Int,\n  headers: List(Header),\n  body: BitArray,\n)\n Received when you use the `WithBody(True)` Option\n\nEmptyResponse(status: Int, headers: List(Header))\n This is received on a HEAD request when response succeeded\n\nAsyncResponse(client_ref: ClientRef)\n This is received when used with the option Async\n You can use the passed in client ref to disambiguate messages received\n\nSynonyms:\nhttpp/hackney.HackneyResponse\nhttpp/hackney HackneyResponse","url":"httpp/hackney.html#HackneyResponse"},{"doc":"httpp/hackney","title":"HttppMessage","content":"pub type HttppMessage {\n  Status(Int)\n  Headers(List(Header))\n  Binary(BitArray)\n  Redirect(String, List(Header))\n  SeeOther(String, List(Header))\n  DoneStreaming\n  NotDecoded(Dynamic)\n}\n\nStatus(Int)\n\n\nHeaders(List(Header))\n\n\nBinary(BitArray)\n\n\nRedirect(String, List(Header))\n\n\nSeeOther(String, List(Header))\n\n\nDoneStreaming\n\n\nNotDecoded(Dynamic)\n In case we couldn&#39;t decode the message, you&#39;ll get the dynamic version\n\nSynonyms:\nhttpp/hackney.HttppMessage\nhttpp/hackney HttppMessage","url":"httpp/hackney.html#HttppMessage"},{"doc":"httpp/hackney","title":"Options","content":"pub type Options {\n  WithBody(Bool)\n  MaxBody(Int)\n  Async\n  StreamTo(process.Pid)\n  FollowRedirect(Bool)\n  MaxRedirect(Int)\n  BasicAuth(BitArray, BitArray)\n}\n\nWithBody(Bool)\n Receive a binary response\n\nMaxBody(Int)\n If using `WithBody(True)`, set maximum body size\n\nAsync\n Receive a `ClientRef` back\n\nStreamTo(process.Pid)\n Receive the response as message, use the function `selecting_http_message`\n\nFollowRedirect(Bool)\n Follow redirects, this enables the messages `Redirect` and `SeeOther`\n\nMaxRedirect(Int)\n Max number of redirects\n\nBasicAuth(BitArray, BitArray)\n Basic auth username/password\n\nSynonyms:\nhttpp/hackney.Options\nhttpp/hackney Options","url":"httpp/hackney.html#Options"},{"doc":"httpp/hackney","title":"body","content":"pub fn body(ref client_ref: ClientRef) -&gt; Result(BitArray, Error)\n retrieve the full body from a client_ref\nSynonyms:\nhttpp/hackney.body\nhttpp/hackney body","url":"httpp/hackney.html#body"},{"doc":"httpp/hackney","title":"body_string","content":"pub fn body_string(\n  ref client_ref: ClientRef,\n) -&gt; Result(String, Error)\n retrieve the full body from a client ref as a string\nSynonyms:\nhttpp/hackney.body_string\nhttpp/hackney body_string","url":"httpp/hackney.html#body_string"},{"doc":"httpp/hackney","title":"selecting_http_message","content":"pub fn selecting_http_message(\n  selector: Selector(a),\n  mapping transform: fn(ClientRef, HttppMessage) -&gt; a,\n) -&gt; Selector(a)\n if sending with async, put this in your selector to receive messages related to your request\nSynonyms:\nhttpp/hackney.selecting_http_message\nhttpp/hackney selecting_http_message","url":"httpp/hackney.html#selecting_http_message"},{"doc":"httpp/hackney","title":"send","content":"pub fn send(\n  a: Method,\n  b: String,\n  c: List(#(String, String)),\n  d: BytesBuilder,\n  e: List(Options),\n) -&gt; Result(HackneyResponse, Error)\n Send hackney a request, this is basically the direct\nSynonyms:\nhttpp/hackney.send\nhttpp/hackney send","url":"httpp/hackney.html#send"},{"doc":"httpp/hackney","title":"httpp/hackney","content":" This module contains the base code to interact with hackney in a low-level manner","url":"httpp/hackney.html"},{"doc":"httpp/async","title":"send","content":"pub fn send(\n  req: Request(BytesBuilder),\n) -&gt; Result(Subject(Response(BitArray)), Error)\n Send a request and receive a subject which you can receive to get the response\nSynonyms:\nhttpp/async.send\nhttpp/async send","url":"httpp/async.html#send"},{"doc":"httpp/async","title":"httpp/async","content":"","url":"httpp/async.html"},{"doc":"httpp/send","title":"send","content":"pub fn send(\n  req: Request(String),\n) -&gt; Result(Response(String), Error)\n\nSynonyms:\nhttpp/send.send\nhttpp/send send","url":"httpp/send.html#send"},{"doc":"httpp/send","title":"send_bits","content":"pub fn send_bits(\n  req: Request(BytesBuilder),\n) -&gt; Result(Response(BitArray), Error)\n\nSynonyms:\nhttpp/send.send_bits\nhttpp/send send_bits","url":"httpp/send.html#send_bits"},{"doc":"httpp/send","title":"httpp/send","content":"","url":"httpp/send.html"},{"doc":"httpp/streaming","title":"Message","content":"pub type Message {\n  Bits(BitArray)\n  Done\n}\n\nBits(BitArray)\n\n\nDone\n\n\nSynonyms:\nhttpp/streaming.Message\nhttpp/streaming Message","url":"httpp/streaming.html#Message"},{"doc":"httpp/streaming","title":"StreamingRequestHandler","content":"pub type StreamingRequestHandler(state, message_type) {\n  StreamingRequestHandler(\n    initial_state: state,\n    req: Request(BytesBuilder),\n    on_data: fn(Message, Response(Nil), state) -&gt;\n      Result(state, ExitReason),\n    on_message: fn(message_type, Response(Nil), state) -&gt;\n      Result(state, ExitReason),\n    on_error: fn(hackney.Error, Option(Response(Nil)), state) -&gt;\n      Result(state, ExitReason),\n    initial_response_timeout: Int,\n  )\n}\n This defines the behaviour of the request handler\n *NOTE*: if the on_error handler does not receive a response, the handler will be shut down regardless of if it returns an Ok() result\n if the initial response does not arrive within the timeout, the on_error handler will receive the `TimedOut` error\nStreamingRequestHandler(\n  initial_state: state,\n  req: Request(BytesBuilder),\n  on_data: fn(Message, Response(Nil), state) -&gt;\n    Result(state, ExitReason),\n  on_message: fn(message_type, Response(Nil), state) -&gt;\n    Result(state, ExitReason),\n  on_error: fn(hackney.Error, Option(Response(Nil)), state) -&gt;\n    Result(state, ExitReason),\n  initial_response_timeout: Int,\n)\n\n\nSynonyms:\nhttpp/streaming.StreamingRequestHandler\nhttpp/streaming StreamingRequestHandler","url":"httpp/streaming.html#StreamingRequestHandler"},{"doc":"httpp/streaming","title":"start","content":"pub fn start(\n  handler: StreamingRequestHandler(a, b),\n) -&gt; Result(Subject(b), StartError)\n Starts a streaming request manager, based on the spec\nSynonyms:\nhttpp/streaming.start\nhttpp/streaming start","url":"httpp/streaming.html#start"},{"doc":"httpp/streaming","title":"httpp/streaming","content":" This module allows you to make an http request to a server and receive a streamed response back which\n is sent to a process managing it. You can also define a custom message type and send messages and state\n to this response handler.","url":"httpp/streaming.html"},{"doc":"httpp/sse","title":"SSEEvent","content":"pub type SSEEvent {\n  Event(event_type: Option(String), data: String)\n  Closed\n}\n\nEvent(event_type: Option(String), data: String)\n\n\nClosed\n\n\nSynonyms:\nhttpp/sse.SSEEvent\nhttpp/sse SSEEvent","url":"httpp/sse.html#SSEEvent"},{"doc":"httpp/sse","title":"SSEManagerMessage","content":"pub type SSEManagerMessage {\n  Shutdown\n}\n\nShutdown\n\n\nSynonyms:\nhttpp/sse.SSEManagerMessage\nhttpp/sse SSEManagerMessage","url":"httpp/sse.html#SSEManagerMessage"},{"doc":"httpp/sse","title":"event_source","content":"pub fn event_source(\n  req: Request(BytesBuilder),\n  subject: Subject(SSEEvent),\n) -&gt; Result(Subject(SSEManagerMessage), StartError)\n Send a request to a server-sent events endpoint, and receive events\n back on a subject you provide\nSynonyms:\nhttpp/sse.event_source\nhttpp/sse event_source","url":"httpp/sse.html#event_source"},{"doc":"httpp/sse","title":"httpp/sse","content":"","url":"httpp/sse.html"}]);